#include	"mview.h"
#include	"window.h"
#include	<io.h>

static WindowID	Swp;
static int	OnSwitch, TargetMen;

static int	WinScExec( WindowID, EventInfo* );
static int	WinExec( WindowID, EventInfo* );


void
winlist( wild, attr )
char	*wild;
int	attr;
{
	char	files_buffer[150],		/* files(fBNg)p */
			files_atr;
	int	files_date;
	size_t	files_len;
	char	*FoundFile;

	FoundFile= files( files_buffer, &files_atr, &files_date, &files_len, wild, attr );
	while( FoundFile ){			/* A */
		if( strcmp( FoundFile, "." ) && strcmp( FoundFile, ".." ) ){
			strcpy( WinMember[WinMax++].name, FoundFile );
		}
	 	FoundFile= nfiles( files_buffer, &files_atr, &files_date, &files_len );
	}
	return;
}

int
WinScExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[MEMBER_MAX+1], *dp= dbuf;
	int	i;
	
	switch( info->option ){
	case EventOpen:
		for( i= 0; i < WinMax; i++ )	WinOn[i]= 0;
		TargetMen= 0;	/* 0ԂftHgőI */
		if( !OnSwitch ){
			WinOnNum= 1;
			WinOn[0]= 1;	/* }[N */
		}
		Swp= wp;
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		for( i= 0; i < WinMax; i++ ){
			DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
							WinOn[i]? (AttrDefault ^ 8):AttrDefault, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:
		if( info->LeftON && (i= info->y / 12) < WinMax ){
			if( OnSwitch ){			/* I */
				if( WinOn[i] ){
					WinOn[i]= 0;
					WinOnNum--;
					DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
							AttrDefault, 12 );
				}else {
					WinOn[i]= 1;
					WinOnNum++;
					DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
							AttrDefault ^ 8, 12 );
				}
			}else {
					WinOn[ TargetMen ]= 0;
					WinOn[i]= 1;
					DrawSetSymbol( dp++, 0, TargetMen * 12, WinMember[TargetMen].name,
							AttrDefault, 12 );
					DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
							AttrDefault ^ 8, 12 );
			}
			TargetMen= i;
			WindowDraw( wp, dbuf, dp - dbuf );
		}
		return TRUE;
	}
	return FALSE;
}

int
WinExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[5], *dp= dbuf;

	switch( info->option ){
	case EventOpen:
		WinOnNum = 0;
		WindowSetEventAttr( wp, EventAttrDefault );
		WindowScrollOpen( 0, 0, 150, 180, wp, 150,(WinMax*12<=176)?176:WinMax*12,
					DirectionY, 12, 12, WinScExec );
		WindowRedraw( wp );
		return	TRUE;
	case EventClose:
		WindowClose( Swp );
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetSymbol( dp++, 18, 184, "  Ok  ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 98, 184, "Cancel", AttrDefault, 12 );
		DrawSetLine( dp++, 16, 182,  55, 197, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 96, 182, 135, 197, ShadowUp, OptionShadow );
		WindowDraw( wp, dbuf, dp - dbuf );
		WindowRedraw( Swp );
		return	TRUE;
	case EventMouseSwitch:
		if( info->y <= 180 ){
			return WindowSendEvent( Swp, info );
		}
		return TRUE;
	}
	return	FALSE;
}

static EventInfo	myinfo;

int
WinManager(	mode )
int	mode;
{
	WindowID	cwp, nwp;

	int	x, y;
	
	OnSwitch= mode;
	WindowGetScreenPosition( Bwp, &x, &y );
	cwp= WindowSimpleOpen( x + WINDOW_X, y + WINDOW_Y, 150, 200, NULL, WinExec );

	for(;;){
		if( !WindowGetEventInfo( &myinfo ) )	continue;
		nwp= WindowGetChild( WindowRootID, &myinfo );
		if( nwp == cwp ){
			if( myinfo.option == EventClose ){
				TargetMen= -1;
				break;
			}
			if( myinfo.LeftON ){
				if( myinfo.y >182 && myinfo.y < 197 ){
					if( myinfo.x > 16 && myinfo.x < 55 ){
						break;	/* OK */
					}else if( myinfo.x > 96 && myinfo.x < 135 ){
						TargetMen= -1;
						break;	/* Cancel */
					}
				}
			}else if( myinfo.option == EventKey ){
				if( myinfo.KeyCode == '\r' ){
					break;	/* RET */
				}else if( myinfo.KeyCode == '\x1b' ){
					TargetMen= -1;
					break;	/* ESC */
				}
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}
		if( nwp && nwp != Bwp ){
			WindowSendEvent( nwp, &myinfo );
		}
	}
	WindowClose( cwp );
	return TargetMen;
}
